-- ddr_controller package

library ieee;
use ieee.std_logic_1164.all;

package ddr_controller_pack is
	constant DDR_ADDRESS_WIDTH : integer := 13;
	constant DDR_COLUMN_ADDRESS_WIDTH : integer := 10;
	constant USER_INPUT_ADDRESS_WIDTH : integer := DDR_ADDRESS_WIDTH + DDR_COLUMN_ADDRESS_WIDTH + 2;
    constant MAX_REFRESH_COUNT_LENGTH : integer := 6;
	constant MAX_REFRESH_COUNT : std_logic_vector(MAX_REFRESH_COUNT_LENGTH-1 downto 0) := "110000"; -- 48
	-- MAX_REFRESH_COUNT́ADDR SDRAM̃NbN16NbNtbVԂɂǂꂾJEg邩Ō
	-- ݂DDRNbN100MHz(10ns)ŃtbVԂ7800nsA7800/(10*16)=48.748ƂȂ
	constant QUANTITY_OF_CLK_OUTPUT : integer := 1; -- NbNo͂̌
	constant CAS_LATENCY : integer := 2;
	
	-- dON̎200usԁAckelowɂāADQ,DQSnCECs[_XɂB̂߂̃JE^p̍ől
	constant MAX_INITIAL_COUNT_VAL : std_logic_vector := "10011100010"; -- 1250
	
	-- DDR̃f[^߂p[^
	constant DDR_DATA_WIDTH : integer := 16; -- DDR SDRAM̃f[^
	constant DDR_DQS_DM_WIDTH : integer := DDR_DATA_WIDTH/8; -- DDR SDRAMDQS̕
	constant INTERFACE_DATA_WIDTH : integer := DDR_DATA_WIDTH*2; -- DDR SDRAM̃f[^̔{
	constant INTERFACE_MASK_WIDTH : integer := INTERFACE_DATA_WIDTH/8; -- BE̕
end ddr_controller_pack;
