-- upper_4hex_dataݒ肷邽߂̃gbv

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity input_4hex_top is
	port(
		clk : in std_logic;
		reset : in std_logic;
		rot_a : in std_logic;
		rot_b : in std_logic;
		rot_center : in std_logic;
		right_level : out std_logic; -- rightpXBright_ack܂1̂܂
		right_ack : in std_logic;
		left_level : out std_logic; -- leftpXBleft_ack܂1̂܂
		left_ack : in std_logic;
		cursor_move : out std_logic; -- 0̎J[\̈ړA1̎w肳ꂽJEgAbvA_E
		cursor_position : out std_logic_vector(3 downto 0); -- J[\̈ʒuoCiŎBԍ3
		cursor_return : in std_logic; -- PicoBlazeJ[\[ɖ߂
		upper_4hex_data : out std_logic_vector(15 downto 0) -- LCD̍s416i
	);
end input_4hex_top;

architecture RTL of input_4hex_top is
component rot_enc_cont
	port(
		clk : in std_logic;
		reset : in std_logic;
		rot_a : in std_logic;
		rot_b : in std_logic;
		rot_center : in std_logic;
		right_pulse : out std_logic;
		left_pulse : out std_logic;
		center_pulse : out std_logic
	);
end component;
component input_4hex_val
	port(
		clk : in std_logic;
		reset : in std_logic;
		right_pulse : in std_logic;
		left_pulse : in std_logic;
		center_pulse : in std_logic; -- [^[EGR[_̃XCb`pX
		right_level : out std_logic; -- rightpXBright_ack܂1̂܂
		right_ack : in std_logic;
		left_level : out std_logic; -- leftpXBleft_ack܂1̂܂
		left_ack : in std_logic;
		cursor_move : out std_logic; -- 0̎J[\̈ړA1̎w肳ꂽJEgAbvA_E
		cursor_position : out std_logic_vector(3 downto 0); -- J[\̈ʒuoCiŎBԍ3
		cursor_return : in std_logic; -- PicoBlazeJ[\[ɖ߂
		upper_4hex_data : out std_logic_vector(15 downto 0) -- LCD̍s416i
	);
end component;
signal right_pulse : std_logic;
signal left_pulse : std_logic;
signal center_pulse : std_logic;
begin
	rot_enc_cont_inst : rot_enc_cont port map(
		clk => clk,
		reset => reset,
		rot_a => rot_a,
		rot_b => rot_b,
		rot_center => rot_center,
		right_pulse => right_pulse,
		left_pulse => left_pulse,
		center_pulse => center_pulse
	);
	input_4hex_val_inst : input_4hex_val port map(
		clk => clk,
		reset => reset,
		right_pulse => right_pulse,
		left_pulse => left_pulse,
		center_pulse => center_pulse,
		right_level => right_level,
		right_ack => right_ack,
		left_level => left_level,
		left_ack => left_ack,
		cursor_move => cursor_move,
		cursor_position => cursor_position,
		cursor_return => cursor_return,
		upper_4hex_data => upper_4hex_data
	);
end RTL;
		
