-- Frequncy Divider for rejection switch chattering
-- XCb`̃`^Oh~邽߂ɃTvONbNƂ100Hz̃Cl[u𐶐
-- }X^[NbN200Hzsw_enaɕ܂B
-- NbNgclk_frequencyKHzPʂŐݒ肵ĂBdefault33MHzłB
-- swcnt19rbgɂȂĂ̂ŁAclk_frequency65536ȏ̏ꍇ̓rbg𑝂₵ĂB

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;

entity SWDiv is
	generic(
		clk_frequency : integer := 50000 -- KHz
	);
	port(
		clk, reset : in std_logic;
		sw_ena : out std_logic	
	);
end SWDiv;

architecture RTL of SWDiv is
signal swcnt : std_logic_vector(19 downto 0);
begin
	process(reset, clk) begin -- Switch sampling frequency is 200Hz
		if reset='1' then
			swcnt <= (others => '0');
		elsif clk'event and clk='1' then
--			if swcnt = conv_std_logic_vector(clk_frequency*5, 19) then
			if swcnt = conv_std_logic_vector(clk_frequency, 20) then
				swcnt <= (others => '0');
			else
				swcnt <= swcnt + 1;
			end if;
		end if;
	end process;
	
	sw_ena <= '1' when swcnt = conv_std_logic_vector(clk_frequency, 20) else '0';
end RTL;
